Index: git_u-boot/cpu/arm920t/s3c24x0/nand.c
===================================================================
--- git_u-boot.orig/cpu/arm920t/s3c24x0/nand.c	2007-05-29 10:28:18.000000000 +0800
+++ git_u-boot/cpu/arm920t/s3c24x0/nand.c	2007-05-29 10:28:47.000000000 +0800
@@ -102,6 +102,60 @@
 			return 0;
 	}
 }
+/*
+ * 4G Nand flash chip select function
+ */
+void hxd8_nand_select_chip(struct mtd_info *mtd, int chip)
+{
+	struct nand_chip *this = mtd->priv;
+	S3C24X0_GPIO * const gpio = S3C24X0_GetBase_GPIO();
+	
+	if (chip == -1 ){
+		gpio->GPGDAT |= (1<<1);
+		gpio->GPADAT |= (1<<14);
+		gpio->GPADAT |= (1<<15);
+		gpio->GPADAT |= (1<<16);
+		this->hwcontrol(mtd, NAND_CTL_CLRNCE);
+		return ;
+	}
+	
+	switch(nand_curr_device){
+	case 0:
+		gpio->GPGDAT &=  ~(1 << 1);
+		gpio->GPADAT |= (1<<14);
+		gpio->GPADAT |= (1<<15);
+		gpio->GPADAT |= (1<<16);
+		this->hwcontrol(mtd, NAND_CTL_SETNCE);
+		break;
+	case 1:
+		gpio->GPGDAT |= (1<<1);
+		gpio->GPADAT |= (1<<14);
+		gpio->GPADAT &=  ~(1 << 15);
+		gpio->GPADAT |= (1<<16);
+		this->hwcontrol(mtd, NAND_CTL_SETNCE);
+		break;
+	case 2:
+		gpio->GPGDAT |= (1<<1);
+		gpio->GPADAT |= (1<<14);
+		gpio->GPADAT |= (1<<15);
+		gpio->GPADAT &=  ~(1 << 16);
+		this->hwcontrol(mtd, NAND_CTL_SETNCE);
+		break;
+	case 3:
+		gpio->GPGDAT |= (1<<1);
+		gpio->GPADAT &=  ~(1 << 14);
+		gpio->GPADAT |= (1<<15);
+		gpio->GPADAT |= (1<<16);
+		this->hwcontrol(mtd, NAND_CTL_SETNCE);
+		break;
+
+	default:
+		printf("nand_curr_device:%d",nand_curr_device);
+		BUG();
+	}
+}
+
+
 #endif
 
 static void s3c2410_hwcontrol(struct mtd_info *mtd, int cmd)
@@ -273,7 +327,7 @@
 
 #if defined(CONFIG_HXD8)
 	//printk("Initial new cs\n");
-	//nand->select_chip = hxd8_nand_select_chip;
+	nand->select_chip = hxd8_nand_select_chip;
 	nand->dev_ready = hxd8_dev_ready;
 #endif
 
Index: git_u-boot/drivers/nand/nand.c
===================================================================
--- git_u-boot.orig/drivers/nand/nand.c	2007-05-29 10:28:29.000000000 +0800
+++ git_u-boot/drivers/nand/nand.c	2007-05-29 10:29:33.000000000 +0800
@@ -65,6 +65,7 @@
 	int i;
 	unsigned int size = 0;
 	for (i = 0; i < CFG_MAX_NAND_DEVICE; i++) {
+		nand_curr_device = i;
 		nand_init_chip(&nand_info[i], &nand_chip[i], base_address[i]);
 		size += nand_info[i].size;
 		if (nand_curr_device == -1)
